require 'active_support/core_ext/string/conversions'

module ActiveModel
  class Coercer
    def initialize(type)
      @coercion_type = self.class.defined_coercions.fetch(type)
    end

    def cast(value)
      @coercion_type.new(value).to_value
    end

    class << self
      def defined_coercions
        {
          integer: ActiveModel::Coercions::Types::Integer,
          float: ActiveModel::Coercions::Types::Float,
          symbol: ActiveModel::Coercions::Types::Symbol,
          time: ActiveModel::Coercions::Types::Time,
          date: ActiveModel::Coercions::Types::Date,
          datetime: ActiveModel::Coercions::Types::DateTime,
          boolean: ActiveModel::Coercions::Types::Boolean
        }
      end
    end
  end
end
