module ActiveModel
  module Coercions
    attr_accessor :attributes

    class << self
      def included(base)
        base.extend(ClassMethods)
        base.class_eval { @declared_coercions = {} }
      end
    end

    def attributes
      @attributes ||= {}
    end

    module ClassMethods

      attr_accessor :declared_coercions

      def attribute(attr, type)
        @declared_coercions[attr] = Coercer.new(type)
      end
    end
  end
end
